// wɓwxt@CovO

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include <sys/types.h>
#include <time.h>
#include <sys/utime.h>

#include "d88.h"

static unsigned char dir[0x400*3];				// Directory (1024byte x 3sector)
static int fat[0x400/2];						// FAT
static unsigned char buffer[0x400*5*80];		// 1024byte x 5sector x 80track
static char dirpath[FILENAME_MAX];				// 쐬fBNg

int main(int argc, char *argv[])
{
	int mode=1;

	if (argc<2 && argc>4)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: gokudofile image [-d]\n");
		fprintf(stderr, "       -d : not make sub directory\n");
		return 1;
	}

	if (argc==3 && !strcmp(argv[2],"-d"))
	{
		mode=0;
	}

	D88 disk;
	FILE *fp;

	// t@CJG[ɂȂ
	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();	// fBXNC[W

	for (int diskno = 0; diskno < numdisk; diskno++)	// C[W̏
	{
		disk.SelectDisk(diskno);
		sprintf(dirpath,"%03d",diskno);		// fBNg̐
		if (mode)
		{
			_mkdir(dirpath);				// fBNg쐬
			_chdir(dirpath);				//
			printf("\n[%s] -> %s\n",disk.GetDiskName(),dirpath);
		}

		disk.SetRecordRange(0x01,0x05);
		disk.ReadDATA(1, 0, 1, 2, 3, dir, sizeof(dir));	// fBNgŜǂݍ(track=1,sec=2`4)

		// Track 1ȍ~fBXNC[WۂƓǂݍ
		for (int trk = 1; trk < 80; trk++)
		{
			disk.ReadDATA(trk, trk>>1, trk&1, 0x01, 0x03, &buffer[0x400*5*trk], 0x400*5);
		}

		// FATzɊi[
		for (int i=0; i<sizeof(fat); i++)
		{
			fat[i] = buffer[0x400*5+i*2] + buffer[0x400*5+i*2+1]*0x100;
		}

/*
		fp = fopen("dirdat", "wb");			// for debug
		fwrite(dir, 1, sizeof(dir), fp);
		fclose(fp);
		fp = fopen("fatdat", "wb");			// for debug
		fwrite(fat, 1, sizeof(fat), fp);
		fclose(fp);
		fp = fopen("buffer", "wb");			// for debug
		fwrite(buffer, 1, sizeof(buffer), fp);
		fclose(fp);
*/

		// t@C̐؂o
		for (int fn=0; fn<(sizeof(dir)/0x10); fn++)
		{
			unsigned char *ent = &dir[fn*0x10];		// fBNgGg|C^`
			if (*ent == 0x00) break;				// fBNg̍Ō

			char fname[FILENAME_MAX];				// t@C

			int i;
			int fnp = 0;
			for (i=0; i<8; i++)
			{
				char c = ent[i];		// t@CPo
				if (c==' ') break;
				fname[fnp++] = c;		// t@C\
			}
			if (ent[8] != ' ')			// gqKvȂt
			{
				fname[fnp++] = '.';
			}
			for (i=8; i<11; i++)		// 悤Ɋgqo
			{
				char c = ent[i];
				if (c==' ') break;
				fname[fnp++] = c;
			}
			fname[fnp++] = '\0';		// ̍Ō

			int cluster = ent[0x0c]+ent[0x0d]*0x100;	// JnNX^
			printf("%-12s\n",fname);

			fp = fopen(fname, "wb");	// o̓t@CI[v
			if (fp == NULL) continue;

			do
			{
//				printf ("%03x ",cluster);
				fwrite(&buffer[cluster*0x400], 1, 0x400, fp);	// 1NX^
				if (ferror(fp))
				{
					fprintf(stderr, "t@C߂܂. \n");
					return 1;
				}
				cluster = fat[cluster];		// FAT`FCH
				if ((cluster != 0xffff) && (cluster >= 5*80))
				{
					fprintf(stderr,"\nNX^jĂ܂.\n");
					return 1;
				}
			} while (cluster != 0xffff);
//			printf("\n");
			fclose(fp);		// t@CN[Y
		}
		if (mode) _chdir("..");		// efBNg
	}
	return 0;
}
